# balle-4-murs.py
from tkinter import *
from random import randint

root = Tk()
root.resizable(False,False)
SIZE = 400
canvas = Canvas(root, width=SIZE, height=SIZE, bg='yellow')
canvas.pack()

# parametres physiques
GRAV = 0.5                # acceleration gravitationnelle
FROT = 0.93               # frottement (multiplicatif)

# etat initial de la balle
x = 40
y = 50
dx = randint(-20,20)
dy = randint(-20,20)
r = 40

def animation() :
    global x,y,dx,dy      # <----- !!!
    #print('y = {} et dx = {} et dy = {}'.format(x,dx,dy))       # debug only
    xs = x + dx             # prochaine position virtuelle de la balle
    ys = y + dy
    if ys > SIZE - r :      # collision mur bas
        y = SIZE - r
        dy = dy - GRAV
        dy = -dy * FROT
        dx = dx * FROT
    elif ys < r :           # collision mur haut
        y = r
        dy = -dy * FROT
        dx = dx * FROT
    elif xs < r :           # collision mur gauche
        x = r
        dx = -dx * FROT
        dy = dy * FROT
    elif xs > SIZE - r :    # collision mur droit
        x = SIZE - r
        dx = -dx * FROT
        dy = dy * FROT
    else :                  # pas de collision, aucun frottement (dans le vide)
        x = xs
        y = ys
        dy = dy + GRAV
    canvas.delete(ALL)
    canvas.create_oval(x-r,y-r,x+r,y+r,fill='red')
    if not almost_stopped() :
        canvas.after(10,animation)     # le timer de l'animation : 10 ms
    else :
        print('fini !')

def almost_stopped() :
    return (abs(y - (SIZE - r)) < 1) and (abs(dx) < 0.2)

# Oups, les objets quantiques, s'ils sont localisés, ne sont jamais au repos :
import webbrowser
webbrowser.open('https://www.quora.com/Does-quantum-mechanics-imply-that-particles-can-never-be-at-rest')

# All engines running !
animation()
root.mainloop()
