# balle-verticale.py
# Python en L1-Info, Nice, Automne 2017
# Utilisation de tkinter pour une animation simple
# Une balle qui rebondit à la verticale
# Avec gravitation et frottement
# Programmation procedurale, sans classes d'objets
# VERSION 2 : pres du sol, on force la balle tangente au sol (d'ou une petite erreur
# non percue visuellement).
# Assez realiste dans un jeu video AVEC frottements...

from tkinter import *

root = Tk()
root.resizable(False,False)    # dimensions de la fenetre fixes
HAUTEUR = 400
LARGEUR = 80
canvas = Canvas(root, width=LARGEUR, height=HAUTEUR, bg='yellow')
canvas.pack()

# parametres physiques
GRAV = 0.5                # acceleration gravitationnelle (additive)
FROT = 0.93               # frottement (multiplicatif)

# etat initial de la balle, dy est la vitesse verticale et r le rayon
x = 40
y = 100
dy = 0
r = 20

def animation() :
    global y, dy    # <------ !!!
    #print('y = {} et dy = {}'.format(y,dy))        # pour le debug seulement !
    ys = y + dy              # prochaine position de la balle
    if ys <= HAUTEUR - r :   # si la balle est loin du sol...
        y = ys
        dy = dy + GRAV
    else :
        y = HAUTEUR - r      # on la pose au sol !
        dy = dy - GRAV
        dy = -dy * FROT
    canvas.delete(ALL)
    canvas.create_oval(x-r,y-r,x+r,y+r,fill='red')
    if not almost_stopped() :
        canvas.after(10,animation)     # le timer de l'animation : 10 ms
    else :
        print('fini !')

def almost_stopped() :
    return (abs(y - (HAUTEUR - r)) < 2) and (abs(dy) < 2)

# Oups, les objets quantiques, s'ils sont localisés, ne sont jamais au repos :
import webbrowser
webbrowser.open('https://www.quora.com/Does-quantum-mechanics-imply-that-particles-can-never-be-at-rest')

# Run Forrest, run !
animation()
root.mainloop()
